/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-07-30 03:39
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef long double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

const ll MAXN = 1e18 + 3;

set<ll> poss;

void precalc(){
    ll amt, curpow;
    int step;
    bool deep = true;
    for(ll i = 2; deep; i++){
        if( i % 1000000 == 0) cerr << i << endl;
        amt = 1ll + i;
        curpow = i * i;
        step = 2;
        while(1){
            amt += curpow;
            poss.insert(amt);
            if(MAXN / i < curpow){
                if(step <= 2){
                    deep = false;
                    fprintf(stderr, "Broke at step 2! %d\n", i);
                }
                break;
            }
            curpow *= i;
            assert (curpow > 0);
            step++;
        }
    }
}

void solve(){
    ll N;
    cin >> N;
    
    // depth more than two
    bool snowflake = poss.find(N) != poss.end();

    // snowflake of depth 2
    // check N - 1 == (k + 1) * k for some k
    ll root = sqrt(N);
    if (not snowflake and root >= 2){
        assert(root * root <= N);
        assert(N < (root + 1) * (root + 1));
        snowflake = (N - 1 == (root + 1) * root);
    }

    cout << (snowflake ? "YES" : "NO") << endl;
}

int main(){
    cout << fixed << setprecision(8);
    int T;
    cin >> T;

    precalc();

    while(T--)
        solve();
}
        
